#!/bin/sh
#
# Make the Version.lua file, containing the version number from the TOC file

awk '/^##[\t ]+Version:/ {						\
    n_nums = split($3, vers, "\.");					\
    if (n_nums != 3) {							\
        printf("Error: mk_version.sh read back %d version numbers\n",	\
               n_nums) > "/dev/stderr";					\
        exit 1;								\
    }									\
    printf("DestroDummies.version = {};\n");				\
    printf("DestroDummies.version.major = %d;\n", vers[1]);		\
    printf("DestroDummies.version.minor = %d;\n", vers[2]);		\
    printf("DestroDummies.version.release = %d;\n", vers[3]);		\
 }' DestructionForDummies.toc

res=$?
if [ $res -ne 0 ] ; then
    printf "mk_version.sh failed to parse the TOC file; exit code %d\n" $res >&2
    exit 1
else
    exit 0
fi
